Subject: Re: bug#76503: [GCD] Migrating repositories, issues, and patches to Codeberg

From: Tomas Volf <[email-masked]>
Date: Mon, 03 Mar 2025 00:35:20 +0100

Ludovic Courtès <[email-masked]> writes:

> Hi Tomas,
>
> Thanks for reading the proposal.  I pushed a fix for the typos you
> reported.

I am pretty sure it should have not been pushed to the main branch, but
to wip-codeberg (or something similar).  My understanding of GCD-001 and
the README is that main is for approved documents only.

> [..]

>> How do pull request templates work together with AGit flow
>
> Good question, I don’t know, we’ll need to check.
>
>> that (as far as I understand it) is being considered to be mandatory?
>
> That’s not how I see it; I think suggesting it is an option (but also
> from because it provides an interface that some may prefer), but making
> it mandatory now doesn’t seem justified to me.

Agree.

> [..]

>>>   - Within **30 days** after acceptance of this GCD, mailing list
>>>     administrators will set up the `bug-guix` and `guix-patches` mailing
>>>     lists in “Emergency Moderation” mode in the Mailman
>>>     interface—meaning that messages will not get through anymore.
>>
>> This contradicts GCD 001 no?  The 001 requires the GCD to be sent as
>> patch to [email-masked].  How will this be handled?
>
> I think we would amend GCD 001 to change references to the email
> workflow with references to the Codeberg-based workflow.  We should
> probably spell it out here in an extra bullet, along these lines:
>
>   - Once the guix-consensus-document.git repository has been moved to
>     Codeberg, authorized people will apply [the
>     patch](https://issues.guix.gnu.org/XXX) amending GCD 001 to refer to
>     the Codeberg-based workflow.
>
> And so we’d send the patch in question beforehand so everyone can see
> how the GCD is amended.
>
> WDYT?

Yes, that seems good process wise.

I am not really looking forward to reading the debate (given the volume)
in the linear format in the Codeberg's issue tracker (no threading, no
dormant marks, ...), and I am not happy about limiting people able to
comment on GCD proposal to holders for Codeberg account, but both are in
the spirit of this (002) proposal, so it makes sense.

(Hypothetical funny situation would be a GCD about moving *off* Codeberg
due to people having troubles creating account, on which people it is
about would not be able to comment, due to not having an account.  Yes,
yes, just joking.)

>
>> On separate note, there are other projects (well, I know just of
>> Shepherd, are there others?) than Guix using bug-guix and guix-patches,
>> so maybe this GCD should go a bit into how that will be handled.
>
> Maybe with by extending the bullet above:
>
>     […] meaning that messages will not get through anymore.
>     Other projects that were using bug-guix and guix-patches (the
>     Shepherd, Cuirass, etc.) must have set up their own bug-reporting
>     and patch-tracking tools by then.

Sounds good.

> [..]

>>> [fj.el](https://codeberg.org/martianh/fj.el/) is an Emacs interface
>>> similar to `mastodon.el` that lets you view and comment on issues and
>>> pull requests, list repositories, view notifications, and so on.
>>
>> One thing it does not support (based on the README) is the ability to do
>> an actual code review, which is a bummer.
>
> Concretely, it does not let you comment line-by-line so far, which is
> what you would do in the web interface.

Does it at least let you see line-by-line comments from other people?
Sorry for constant questions, but as you might have guessed from the
other thread, I do not have Codeberg account to try it myself.

> [..]

>> Can anyone update other people's pull requests, the way I can
>> currently sent n+1 version of a patch started by someone else?
>
> If I’m not mistaken, the person who creates the pull request decides
> whether they allow others to update it.  (As a reviewer and “owner”,
> I’ve definitely updated other people’s pull requests.)

Can this be enforced on repository level?  So that we could mandate that
all pull requests are editable by anyone, to match how the debbugs work
currently?

>
>>> Note that since Guix requires signed commits by people listed in
>>> `.guix-authorizations`, we will *not* be able to click the “Merge”
>>> button nor to enable auto-merge on build success.
>>
>>>>From the debate I gathered that the merge button can be completely
>> disabled on the Website, I would suggest to put in here that we will do
>> that (to prevent mistakes).
>
> Yes, I added a sentence to that effect and pushed it; let me know if
> anything more should be done in your view.

Nothing more required, the addition looks good.

>
>>> First, everyone will have to create an account and accept [Codeberg’s
>>> Terms of
>>> Use](https://codeberg.org/Codeberg/org/src/branch/main/TermsOfUse.md)
>>> before they can contribute, which can be seen as a step back compared to
>>> the email-based workflow.
>>
>> Something to note here is that "contribute" is used in very wide sense.
>> It contains even just reporting a bug.  We will likely lose *some* bug
>> reports because people will not be willing to jump through the hoops.
>
> That is true, but the same can be said of the current workflow.

People having a working email are a strict superset of people having
Codeberg account, by definition. ^_^

Tomas
-- 
There are only two hard things in Computer Science:
cache invalidation, naming things and off-by-one errors.